struct lock {
	bool *want_in;
	int turn;
};

int other(int me) NO_STEP {
	return 1 - me;
}

void lock(struct lock *l, int me) {
	l->want_in[me] = true;
	l->turn = other(me);

	while (l->want_in[other(me)]
		&& l->turn == other(me))
		;
}

void unlock(struct lock *l, int me) {
	l->want_in[me] = false;
}

void work(struct lock *l, int id) {
	while (true) {
		lock(l, id);
		unlock(l, id);
	}
}

int main(void) {
	struct lock *l = malloc(sizeof(struct lock));
	NO_STEP {
		l->want_in = malloc(sizeof(bool)*2);

		thread_new(&work, l, 1);
		work(l, 0);
	}

	return 0;
}
