void dec_if_possible(int *value, int dec) {
	int orig;
	int write;
	do {
		// Read.
		orig = compare_and_swap(value, 0, 0);
		// Update.
		write = orig;
		if (write >= dec)
			write -= dec;
		// Commit.
	} while (compare_and_swap(value, orig, write) != orig);
}

void work(int *v, int by) {
	while (true) {
		dec_if_possible(v, by);
	}
}

int main(void) {
	int *shared = malloc(sizeof(int));
	NO_STEP {
		*shared = 14;
		thread_new(&work, shared, 5);
		work(shared, 2);
	}

	return 0;
}
